
clear;close;clc;

% be sure that no 'temporary_func4esfit.m' is present in the current
% directory before running


%%%% experimental spectrum

[B,spec,parwt] = eprload('example.DSC'); 

freqexp=parwt.MWFQ/1e9;%GHz
B=(B+0.41)/10; %corrected field in mT

%%%% Simulated spectrum

%Spin Systm 
Sys.g=[2.0084 2.0061 2.0022];
Sys.Nucs='14N';
Sys.A=[16 16 102];%MHz
Sys.logtcorr=[-8.8 -9.6];

%Exp. Settings
Exp=struct('Range',[B(1) B(end)],'mwFreq',freqexp);

%Varying param.
Vary.logtcorr=0.2*[1 1];

%%%% automatic fitting
generate_func4esfit(Sys) 

if isfile('temporary_func4esfit.m')
    disp('temporary_func4esfit.m exists in the current directory')
end


esfit(spec,@temporary_func4esfit,{Sys,Exp},{Vary});


function generate_func4esfit(~)   
  
    fid=fopen('temporary_func4esfit.m','w'); %new function in current directory for esfit
    fprintf(fid,'%s\n','function varargout = temporary_func4esfit(Sys,Exp,SimOpt)');
    fprintf(fid,'%s\n','     Sys1=rmfield(Sys,''logtcorr'');');
    fprintf(fid,'%s\n','     Sys1.logtcorr=[Sys.logtcorr(1) Sys.logtcorr(2) Sys.logtcorr(1)];');
    fprintf(fid,'%s\n','     [x,y]=chili(Sys1,Exp,SimOpt);');
    fprintf(fid,'%s\n','     if nargout==1');
    fprintf(fid,'%s\n','        varargout={y};');
    fprintf(fid,'%s\n','     else');
    fprintf(fid,'%s\n','        varargout={x,y};');
    fprintf(fid,'%s\n','     end');
    fprintf(fid,'%s','end');
    fclose(fid);  

end




